
// TestingDataRayInterfacetoCPlusPlusVS2013Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestingDataRayInterfacetoCPlusPlusVS2013.h"
#include "TestingDataRayInterfacetoCPlusPlusVS2013Dlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CTestingDataRayInterfacetoCPlusPlusVS2013Dlg dialog



CTestingDataRayInterfacetoCPlusPlusVS2013Dlg::CTestingDataRayInterfacetoCPlusPlusVS2013Dlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CTestingDataRayInterfacetoCPlusPlusVS2013Dlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	countGetData = 0; 
}

void CTestingDataRayInterfacetoCPlusPlusVS2013Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_GETDATACTRL1, MyGetDataCtrl);
}

BEGIN_MESSAGE_MAP(CTestingDataRayInterfacetoCPlusPlusVS2013Dlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON2, &CTestingDataRayInterfacetoCPlusPlusVS2013Dlg::OnBnClickedRetrieveImageData)
END_MESSAGE_MAP()


// CTestingDataRayInterfacetoCPlusPlusVS2013Dlg message handlers

BOOL CTestingDataRayInterfacetoCPlusPlusVS2013Dlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	MyGetDataCtrl.StartDriver(); 

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestingDataRayInterfacetoCPlusPlusVS2013Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestingDataRayInterfacetoCPlusPlusVS2013Dlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestingDataRayInterfacetoCPlusPlusVS2013Dlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

BEGIN_EVENTSINK_MAP(CTestingDataRayInterfacetoCPlusPlusVS2013Dlg, CDialogEx)
	ON_EVENT(CTestingDataRayInterfacetoCPlusPlusVS2013Dlg, IDC_GETDATACTRL1, 2, CTestingDataRayInterfacetoCPlusPlusVS2013Dlg::DataReadyGetdatactrl1, VTS_NONE)
END_EVENTSINK_MAP()


void CTestingDataRayInterfacetoCPlusPlusVS2013Dlg::DataReadyGetdatactrl1()
{
//This function will be triggered each time the event occurs
//Write your event handling code here	
}


void CTestingDataRayInterfacetoCPlusPlusVS2013Dlg::OnBnClickedRetrieveImageData(){
	CComVariant MyWCVar = MyGetDataCtrl.GetWinCamDataAsVariant();
	CComSafeArray<short> WCSafeArray; 
	WCSafeArray.Attach(MyWCVar.parray); //attaches SafeArray structure to a CComSafeArray XSafeArray
	short horizontalPixels = MyGetDataCtrl.GetHorizontalPixels();
	short verticalPixels = MyGetDataCtrl.GetVerticalPixels();
	LONG pixelCount = (horizontalPixels*verticalPixels); //In fast resolution, divide the number of pixels in the capture block by 4
	unsigned short * image = new unsigned short[pixelCount];
	for (int k = 0; k < pixelCount; k++){
		image[k] = WCSafeArray[k];
	}
	WCSafeArray.Detach(); //detaches the SafeArray from the CComSafeArray object
	CFile dataSheet;
	CString fName = "ImageData.csv"; 
	bool ok = dataSheet.Open(fName, CFile::modeWrite | CFile::shareDenyNone | CFile::modeCreate | CFile::modeNoTruncate);
	if (ok){
		for (int i = 1; i <= pixelCount; ++i){
			int W = image[i - 1];
			dataSheet.SeekToEnd();
			CString Name;
			if (i == 1){
				Name.Format("%d, ", W);
				dataSheet.Write(Name, Name.GetLength());
			}
			else if (i % (horizontalPixels) == 0){
				Name.Format("%d \n", W);
				dataSheet.Write(Name, Name.GetLength());
			}
			else{
				Name.Format("%d, ", W);
				dataSheet.Write(Name, Name.GetLength());
			}
		}
		dataSheet.Close();
		delete[] image; 
	}
}